#ifndef BEST_HPP
#define BEST_HPP

#include "Common.hpp"
#include "Problem.hpp"
#include "Solution.hpp"

class Best
{
public:
    Best();
    ~Best();

    void load(uint64_t id);
    bool update(const Solution& solution);

    const Solution& getSolution() const { return m_solution; }
    const Image& getResult() const { return m_result; }
    uint64_t getScore() const { return m_score; }
    uint64_t getSimilarity() const { return m_similarity; }
    uint64_t getCost() const { return m_cost; }

private:
    void parse();

private:
    uint64_t m_id;
    Problem m_problem;
    std::string m_solutionData;
    Solution m_solution;
    Image m_result;
    uint64_t m_score;
    uint64_t m_similarity;
    uint64_t m_cost;
};

#endif
