#include "CalcScore.hpp"
#include "CalcSimilarity.hpp"
#include "Eval.hpp"

using std::string;

bool calcScore(const Problem& problem,
               const Solution& solution,
               Image* pResult,
               uint64_t* pScore,
               uint64_t* pSimilarity,
               uint64_t* pCost,
               Image* pErrorImage,
               string* pMsg)
{
    Canvas canvas;
    Image result;
    uint64_t cost = 0;
    if (!eval(problem, solution, canvas, &result, &cost, nullptr, nullptr, pMsg))
    {
        return false;
    }

    uint64_t similarity = calcSimilarity(problem.targetImage, result, pErrorImage);

    uint64_t score = cost + similarity;

    if (pResult) *pResult = std::move(result);
    if (pScore) *pScore = score;
    if (pSimilarity) *pSimilarity = similarity;
    if (pCost) *pCost = cost;
    return true;
}
