#ifndef CANVAS_HPP
#define CANVAS_HPP

#include "Common.hpp"
#include "Rect.hpp"

enum class BlockKind : uint64_t
{
    Simple,
    Cut
};

class Block
{
public:
    Rect rect;
    BlockKind blockKind = BlockKind::Simple;
    uint64_t blockId = 0;
    uint64_t parentBlockNum = 0;
    bool valid = true;
};

class Canvas
{
public:
    std::vector<Block> blocks;
    uint64_t nextBlockId = 0;
};

#endif
