#ifndef EVAL_HPP
#define EVAL_HPP

#include "Common.hpp"
#include "Problem.hpp"
#include "Solution.hpp"
#include "Image.hpp"

bool evalMove(const Problem& problem,
              const Move& move,
              Canvas& canvas,
              Image* pResult = nullptr,
              uint64_t* pCost = nullptr,
              Grid<uint64_t>* pMoveIdxs = nullptr,
              uint64_t moveIdx = (uint64_t)-1,
              std::vector<Rect>* pRects = nullptr,
              std::string* pMsg = nullptr);

bool eval(const Problem& problem,
          const Canvas& initialCanvas,
          const Image& initialImage,
          const std::vector<Move>& solution,
          Canvas& canvas,
          Image* pResult = nullptr,
          uint64_t* pCost = nullptr,
          Grid<uint64_t>* pMoveIdxs = nullptr,
          std::vector<Rect>* pRects = nullptr,
          std::string* pMsg = nullptr);

bool eval(const Problem& problem,
          const std::vector<Move>& solution,
          Canvas& canvas,
          Image* pResult = nullptr,
          uint64_t* pCost = nullptr,
          Grid<uint64_t>* pMoveIdxs = nullptr,
          std::vector<Rect>* pRects = nullptr,
          std::string* pMsg = nullptr);

#endif
