#include "FindColorCache.hpp"

using std::vector;

bool FindColorCache::lookup(const vector<Coord>& coords,
                            Color* pColor)
{
    for (auto& entry : entries)
    {
        if (entry.coords == coords)
        {
            entry.accessTime = nextAccessTime++;
            if (pColor) *pColor = entry.color;
            return true;
        }
    }
    return false;
}

void FindColorCache::add(const vector<Coord>& coords,
                         Color color)
{
    auto& entry = entries.emplace_back();
    entry.coords = coords;
    entry.color = color;
    entry.accessTime = nextAccessTime++;

    if (entries.size() >= 1000)
    {
        std::sort(entries.begin(), entries.end(),
                  [](const Entry& a, const Entry& b) -> bool { return a.accessTime > b.accessTime; });
        entries.resize(500);
    }
}
