#include "FindColors.hpp"
#include "Eval.hpp"
#include "FindColor.hpp"

using std::string;
using std::vector;

void findColors(const Problem& problem,
                Solution& solution)
{
    string msg;

    Canvas canvas;
    Grid<uint64_t> moveIdxs;
    if (!eval(problem, solution, canvas, nullptr, nullptr, &moveIdxs, nullptr, &msg))
    {
        fprintf(stderr, "%s\n", msg.c_str());
        exit(1);
    }

    uint64_t moveCount = solution.size();
    vector<vector<Coord>> moveCoords(moveCount);
    uint64_t width = problem.width;
    uint64_t height = problem.height;
    for (uint64_t y = 0; y < height; y++)
    {
        for (uint64_t x = 0; x < width; x++)
        {
            uint64_t moveIdx = moveIdxs(x, y);
            if (moveIdx != (uint64_t)-1)
            {
                moveCoords[moveIdx].emplace_back(x, y);
            }
        }
    }

    for (uint64_t moveIdx = 0; moveIdx < moveCount; moveIdx++)
    {
        auto& move = solution[moveIdx];
        if (move.moveKind == MoveKind::Color)
        {
            move.color = findColor(problem, moveCoords[moveIdx]);
        }
    }
}
