#ifndef RECT_HPP
#define RECT_HPP

#include "Common.hpp"

class Rect
{
public:
    Rect() : lowX(0), lowY(0), highX(0), highY(0) {}
    Rect(uint64_t lowX_,
         uint64_t lowY_,
         uint64_t highX_,
         uint64_t highY_) :
        lowX(lowX_),
        lowY(lowY_),
        highX(highX_),
        highY(highY_)
    {}

    bool operator==(const Rect& other) const
    {
        return lowX == other.lowX &&
            lowY == other.lowY &&
            highX == other.highX &&
            highY == other.highY;
    }

    bool operator!=(const Rect& other) const
    {
        return lowX != other.lowX ||
            lowY != other.lowY ||
            highX != other.highX ||
            highY != other.highY;
    }

    uint64_t size() const { return (highX - lowX) * (highY - lowY); }

    uint64_t lowX;
    uint64_t lowY;
    uint64_t highX;
    uint64_t highY;
};

#endif
