#ifndef SCORES_HPP
#define SCORES_HPP

#include "Common.hpp"

bool readSubmissions(std::string* pSubmissionsData);
bool writeSubmissions(const std::string& submissionsData);

bool readResults(std::string* pResultsData);
bool writeResults(const std::string& resultsData);

class Submission
{
public:
    uint64_t submissionId = 0;
    uint64_t id = 0;
    std::string submittedAt;
    std::string status;
    uint64_t score = 0;
};

bool parseSubmissions(const std::string& submissionsData,
                      std::vector<Submission>* pSubmissions,
                      std::string* pMsg = nullptr);
bool parseSubmissions(std::vector<Submission>* pSubmissions,
                      std::string* pMsg = nullptr);

void getMine(const std::vector<Submission>& submissions,
             std::vector<uint64_t>* pMine);

class Result
{
public:
    uint64_t id = 0;
    std::string problemName;
    std::string lastSubmittedAt;
    uint64_t submissionCount = 0;
    uint64_t minCost = 0;
    uint64_t overallBestCost = 0;
};

class Results
{
public:
    std::vector<Result> results;
    uint64_t totalCost = 0;
    uint64_t solvedProblemCount = 0;
};

bool parseResults(const std::string& resultsData,
                  Results* pResults,
                  std::string* pMsg = nullptr);
bool parseResults(Results* pResults,
                  std::string* pMsg = nullptr);

void getMine(const Results& results,
             std::vector<uint64_t>* pMine);

void getBest(const Results& results,
             std::vector<uint64_t>* pBest);

#endif
