#ifndef SOLUTION_HPP
#define SOLUTION_HPP

#include "Common.hpp"
#include "Color.hpp"
#include "Problem.hpp"

enum class MoveKind : uint64_t
{
    Color,
    CutX,
    CutY,
    CutXY,
    Swap,
    Merge
};

class Move
{
public:
    MoveKind moveKind = MoveKind::Color;
    uint64_t x = 0;
    uint64_t y = 0;
    uint64_t blockNums[2] = { 0, 0 };
    Color color;
};

typedef std::vector<Move> Solution;

std::string formatSolution(const Problem& problem,
                           const Solution& solution);
bool parseSolution(const Problem& problem,
                   const std::string& str,
                   Solution* pSolution);

#endif
