#include "Common.hpp"
#include "Cleanup.hpp"
#include "Protocol.hpp"
#include "Scores.hpp"

using std::string;
using std::vector;

int main(int argc, char *argv[])
{
    string msg;

    Protocol::init();
    Cleanup cleanupProtocol([](){ Protocol::cleanup(); });

    string resultsData;
    if (!Protocol::getResults(&resultsData, &msg))
    {
        printf("%s\n", msg.c_str());
        return 1;
    }

    Results results;
    if (!parseResults(resultsData, &results, &msg))
    {
        printf("%s\n", msg.c_str());
        return 1;
    }

    if (!writeResults(resultsData))
    {
        printf("Error writing results\n");
        return 1;
    }

    return 0;
}
