#include "Common.hpp"
#include "Cleanup.hpp"
#include "Protocol.hpp"
#include "Scores.hpp"

using std::string;
using std::vector;

int main(int argc, char *argv[])
{
    string msg;

    Protocol::init();
    Cleanup cleanupProtocol([](){ Protocol::cleanup(); });

    string submissionsData;
    if (!Protocol::getSubmissions(&submissionsData, &msg))
    {
        printf("%s\n", msg.c_str());
        return 1;
    }

    vector<Submission> submissions;
    if (!parseSubmissions(submissionsData, &submissions, &msg))
    {
        printf("%s\n", msg.c_str());
        return 1;
    }

    if (!writeSubmissions(submissionsData))
    {
        printf("Error writing submissions\n");
        return 1;
    }

    return 0;
}
