#include "Common.hpp"
#include "ProblemCount.hpp"
#include "Problem.hpp"
#include "CalcSimilarity.hpp"

using std::string;

int main(int argc, char *argv[])
{
    string msg;

    for (uint64_t id = 1; id <= problemCount; id++)
    {
        printf("%2" PRIu64 ": ", id);
        Problem problem;
        if (!loadProblem(id, &problem, &msg))
        {
            printf("%s\n", msg.c_str());
            return 1;
        }

#if 0
        printf("ok\n");
#endif

#if 0
        Color color = problem.targetImage(0, 0);
        printf("[%3" PRIu8 ", %3" PRIu8 ", %3" PRIu8 ", %3" PRIu8 "]\n",
               color.r,
               color.g,
               color.b,
               color.a);
#endif

#if 0
        Image result(problem.width, problem.height);
        uint64_t similarity = calcSimilarity(problem.targetImage, result);
        printf("%6" PRIu64 "\n", similarity);
#endif

#if 1
        printf("%" PRIuZ "\n", problem.initialCanvas.blocks.size());
#endif
    }

    return 0;
}
